/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
	"fmt"
)

// SendMessageType the model 'SendMessageType'
type SendMessageType string

// List of SendMessageType
const (
	SEND_MESSAGE_TYPE_TEXT SendMessageType = "text"
	SEND_MESSAGE_TYPE_IMAGE SendMessageType = "image"
	SEND_MESSAGE_TYPE_VIDEO SendMessageType = "video"
	SEND_MESSAGE_TYPE_AUDIO SendMessageType = "audio"
	SEND_MESSAGE_TYPE_DOCUMENT SendMessageType = "document"
	SEND_MESSAGE_TYPE_LOCATION SendMessageType = "location"
	SEND_MESSAGE_TYPE_CONTACT SendMessageType = "contact"
	SEND_MESSAGE_TYPE_BUTTONS SendMessageType = "buttons"
	SEND_MESSAGE_TYPE_LIST SendMessageType = "list"
	SEND_MESSAGE_TYPE_ORDER_DETAILS SendMessageType = "order_details"
	SEND_MESSAGE_TYPE_ORDER_STATUS SendMessageType = "order_status"
	SEND_MESSAGE_TYPE_REQUEST_LOCATION SendMessageType = "request_location"
	SEND_MESSAGE_TYPE_REQUEST_PHONE_NUMBER SendMessageType = "request_phone_number"
	SEND_MESSAGE_TYPE_REMOVE_KEYBOARD SendMessageType = "remove_keyboard"
	SEND_MESSAGE_TYPE_MEDIA_CAROUSEL SendMessageType = "media_carousel"
	SEND_MESSAGE_TYPE_REACTION SendMessageType = "reaction"
)

// All allowed values of SendMessageType enum
var AllowedSendMessageTypeEnumValues = []SendMessageType{
	"text",
	"image",
	"video",
	"audio",
	"document",
	"location",
	"contact",
	"buttons",
	"list",
	"order_details",
	"order_status",
	"request_location",
	"request_phone_number",
	"remove_keyboard",
	"media_carousel",
	"reaction",
}

func (v *SendMessageType) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := SendMessageType(value)
	for _, existing := range AllowedSendMessageTypeEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid SendMessageType", value)
}

// NewSendMessageTypeFromValue returns a pointer to a valid SendMessageType
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewSendMessageTypeFromValue(v string) (*SendMessageType, error) {
	ev := SendMessageType(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for SendMessageType: valid values are %v", v, AllowedSendMessageTypeEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v SendMessageType) IsValid() bool {
	for _, existing := range AllowedSendMessageTypeEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to SendMessageType value
func (v SendMessageType) Ptr() *SendMessageType {
	return &v
}

type NullableSendMessageType struct {
	value *SendMessageType
	isSet bool
}

func (v NullableSendMessageType) Get() *SendMessageType {
	return v.value
}

func (v *NullableSendMessageType) Set(val *SendMessageType) {
	v.value = val
	v.isSet = true
}

func (v NullableSendMessageType) IsSet() bool {
	return v.isSet
}

func (v *NullableSendMessageType) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSendMessageType(val *SendMessageType) *NullableSendMessageType {
	return &NullableSendMessageType{value: val, isSet: true}
}

func (v NullableSendMessageType) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSendMessageType) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

